%define rrelease p6

%{?_with_sendmail:  %{expand: %%define sendmail 1}}
%{!?_with_sendmail: %{expand: %%define sendmail 0}}

Name: amavisd-new
Version: 20030616
Release: 2.%{rrelease}
Summary: High-performance interface between mailers (MTA) and content checkers.
Group: System Environment/Daemons
License: GPL
URL: http://www.ijs.si/software/amavisd/

Packager: Dag Wieers <dag@wieers.com>
Vendor: Dag Apt Repository, http://dag.wieers.com/home-made/apt/

Source: http://www.ijs.si/software/amavisd/%{name}-%{version}-%{rrelease}.tar.gz
BuildRoot: %{_tmppath}/root-%{name}-%{version}

%{?_with_sendmail:Requires: sendmail >= 8.12}
%{?_with_sendmail:BuildRequires: sendmail-devel >= 8.12}
# These are required to scan compressed archives
Requires: arc >= 5.21e, nomarch >= 1.2, unrar >= 2.71, zoo >= 2.10
Requires: bzip2, file, lha, ncompress, unarj
# These can't seem to be automatically generated :-(
Requires: perl(Archive::Tar), perl(Archive::Zip), perl(Compress::Zlib)
Requires: perl(Convert::TNEF), perl(IO::Stringy), perl-MailTools
Requires: perl(MIME::Base64), perl(MIME::Tools), perl(Unix::Syslog)
Requires: perl(Time::HiRes), perl(Digest::MD5), perl(Digest::SHA1)
Requires: perl(Digest::HMAC), perl(Net::DNS), perl(Net::Server)
Requires: perl
Obsoletes: amavisd < %{version}

%description
AMaViS is a script that interfaces a mail transport agent (MTA) with
one or more virus scanners.
  
Amavisd-new is a development branch created by Mark Martinec that 
adds serveral performance and robustness features. Its partly based on 
work being done on the official amavisd branch. Please see the
README.amavisd-new-RELNOTES file for a detailed description.

Although MTAs currently supported by AMaViS are Exim, Qmail, Postfix, 
and Sendmail; this package was created with Postfix in mind. Please 
refer to the README.postfix file included in the package.

Also, this package comes configured by default to use the H+BEDV
(http://www.hbedv.com/) antivirus package. If you plan to use another 
of the suported virus scanners then you should edit /etc/amavisd.conf.
Please see the README.scanner file.

Available rpmbuild rebuild options :
--with : sendmail

%prep
%setup -q

# This file is embedded here instead of being another source in order
# to the prefix directory
cat > amavisd.sysv << 'EOF'
#!/bin/sh
#
# amavisd       Init script for AMaViS email virus scanner for Postfix for 
#               Red Hat Linux.
#
# chkconfig: 2345 79 31
# description: AMaViS virus scanner for Postfix.
# processname: amavisd
# config: %{_sysconfdir}/amavis.conf
# pidfile: %{_localstatedir}/run/amavisd.pid

# Source function library
. %{_initrddir}/functions

[ -x %{_sbindir}/amavisd ] || exit 0
[ -f %{_sysconfdir}/amavisd.conf ] || exit 0

prog="amavisd"

start() {
	echo -n $"Starting $prog: "
	daemon %{_sbindir}/$prog
	RETVAL=$?
	echo
	[ $RETVAL -eq 0 ] && touch %{_localstatedir}/lock/subsys/$prog
	return $RETVAL
}

stop() {
	echo -n "Shutting down $prog: "
	killproc $prog
	RETVAL=$?
	echo
	[ $RETVAL -eq 0 ] && rm -f %{_localstatedir}/lock/subsys/$prog
	return $RETVAL
}

restart() {
	stop
	start
}

reload() {
	action $"Reloading $prog: " $prog reload
	return $?
}

case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  restart)
	restart
	;;
  reload)
	reload
	;;
  condrestart)
	[ -f %{_localstatedir}/lock/subsys/amavisd ] && restart
	RETVAL=$?
	;;
  status)
	status $prog
	RETVAL=$?
	;;
  *)
	echo "Usage: $prog {start|stop|restart|condrestart|status}"
	exit 1
esac

exit $RETVAL
EOF

%build
%if %{sendmail}
pushd helper-progs
%configure \
    %{?_with_sendmail:--with-sendmail="%{_sbindir}/sendmail"} \
    --with-user="amavis" \
    --with-runtime-dir="%{_localstatedir}/spool/vscan/amavis"
%{__make} %{?_smp_mflags}
popd
%endif

%install
%{__rm} -rf %{buildroot}
%{__install} -d -m 0755 %{buildroot}%{_sbindir}

%if %{sendmail}
pushd helper-progs
%makeinstall
popd
%endif

perl -pi -e "s|= 'vscan'|= 'amavis'|g; \
             s|= 'sweep'|= 'amavis'|g" amavisd.conf
perl -pi -e 's|^\$QUARANTINEDIR =.*|\$QUARANTINEDIR = "%{_localstatedir}/spool/amavis/virusmails";|g' amavisd.conf

%{__install} -D -m 0755 amavisd %{buildroot}%{_sbindir}/amavisd
%{__install} -D -m 0755 amavisd.sysv %{buildroot}%{_initrddir}/amavisd
%{__install} -D -m 0700 amavisd.conf %{buildroot}%{_sysconfdir}/amavisd.conf

%{__install} -d -m 0700 %{buildroot}%{_localstatedir}/spool/amavis/virusmails \
			%{buildroot}%{_localstatedir}/amavis

%clean
%{__rm} -rf %{buildroot}

%pre
if `id vscan >/dev/null 2>&1`; then
    /usr/sbin/usermod -l amavis vscan >/dev/null 2>&1
    /usr/sbin/groupmod -n amavis vscan >/dev/null 2>&1
fi
/usr/sbin/useradd -c "AMaViS email scanner user" -M -s /bin/sh -r amavis \
    -d %{_localstatedir}/amavis 2>/dev/null || :

%post
/sbin/chkconfig --add amavisd
[ -e /etc/postfix/aliases ] || exit 0
if [ -z "`grep "^virusalert:" /etc/postfix/aliases`" ]; then
    echo "virusalert: root" >> /etc/postfix/aliases
    if [ -x /usr/bin/newaliases ] ; then
	/usr/bin/newaliases > /dev/null 2>&1 
    else
	echo "Can't exec newaliases. Please run it manually"
    fi
fi                                

%preun
if [ $1 -eq 0 ] ; then
    /sbin/service amavisd stop &>/dev/null
    /sbin/chkconfig --del amavisd
fi

%postun
if [ $1 -ne 0 ]; then
    /sbin/service amavisd condrestart &>/dev/null
fi

%files
%defattr(-, root, root, 0755)
%doc AAAREADME.first LICENSE MANIFEST RELEASE_NOTES README_FILES/*
%attr(640, root, amavis) %config(noreplace) %{_sysconfdir}/amavisd.conf
%{_initrddir}/amavisd
%{_sbindir}/*
%defattr(-, amavis, root, 0700)
%dir %{_localstatedir}/amavis
%dir %{_localstatedir}/spool/amavis
%dir %{_localstatedir}/spool/amavis/virusmails/

%changelog
* Mon Jul 14 2003 Matthias Saou <matthias.saou@est.une.marmotte.net> - 20030616
- Update to 20030616.
- Added sendmail build option.
- Minor spec and init script changes.
- Simplified the %%pre/%%post scriptlets.
- Added reload capability to the init script and RETVAL stuff too.
- Fixed files being listed twice in %%{_localstatedir}.
- Removed obsoletes perl-specific find-requires/provides.
- Fixed typos in perl requirements...

* Tue Jan 14 2003 Dag Wieers <dag@wieers.com> - 20021227-0
- Initial package. (using dar)

